package com.aliyun.emas.flutter_crashlytics_example;

import android.app.Application;

import com.alibaba.ha.adapter.AliHaAdapter;
import com.alibaba.ha.adapter.AliHaConfig;
import com.alibaba.ha.adapter.Plugin;

import io.flutter.app.FlutterApplication;

public class MainApplication extends FlutterApplication {
	public String mAppkey = "*";
	public String mAppSecret = "*";
	public String mHARSAPublicKey = "*";
	public boolean mUseHttp = true;

	@Override
	public void onCreate() {
		super.onCreate();
		initHa(this);
	}

	private void initHa(Application application) {
		AliHaConfig config = new AliHaConfig();
		config.appKey = mAppkey;         //appkey
		config.appVersion = BuildConfig.VERSION_NAME;         //应用的版本号信箱
		config.appSecret = mAppSecret;  //appsecret
		config.channel = "mqc_flutter_liu100";        //应用的渠道号标记，自定义
		config.userNick = "liubaowen_flutter";
		config.application = application;
		config.context = application.getApplicationContext();
		config.isAliyunos = false;          //是否为yunos
		config.rsaPublicKey = mHARSAPublicKey;    //tlog公钥， 在控制台下载 aliyun-emas-services.json文件，文件内的appmonitor.tlog.rsaSecret字段即为公钥信息（文件下载方式：在 EMAS控制台-> 应用管理  找到对应的应用，点击应用所在区块右上角菜单内的“配置下载”），必填

		AliHaAdapter.getInstance().addPlugin(Plugin.crashreporter);
		AliHaAdapter.getInstance().openDebug(true);
		AliHaAdapter.getInstance().openHttp(mUseHttp);
//		AliHaAdapter.getInstance().setErrorCallback(new ErrorCallback() {
//			@Override
//			public Map<String, String> onError(ErrorInfo callbackInfo) {
//				Map<String, String> infos = new HashMap<>();
//				infos.put("time", "" + System.currentTimeMillis());
//				infos.put("errortype", "" + callbackInfo.getErrorType());
//				return infos;
//			}
//		});
//		AliHaAdapter.getInstance().addCustomInfo("produce", "emas");
//		AliHaAdapter.getInstance().addCustomInfo("type", "test");

		AliHaAdapter.getInstance().start(config);
	}
}
