import 'package:flutter/material.dart';
import 'package:flutter/cupertino.dart';
import 'dart:convert';

import 'package:emas_crashlytics/emas_crashlytics.dart';

class ErrorTrigger extends StatefulWidget {
  @override
  _ErrorTriggertState createState() => _ErrorTriggertState();
}

class _ErrorTriggertState extends State<ErrorTrigger> {
  bool showErrorWidget = false;
  @override
  Widget build(BuildContext context) {
    return Column(
      children: [
        SizedBox(
          height: 15,
        ),

        /// 空指针异常
        RaisedButton(
            onPressed: () async {
              String jsonString = '{ "title": "aliyun", "info": null }';
              Map<String, dynamic> parsedJson = json.decode(jsonString);
              await Future.delayed(Duration(milliseconds: 10));
              print(parsedJson['info']['domain']);
            },
            child: Text('触发 Dart 空指针异常')),
        Divider(
          color: Colors.black,
          height: 30,
        ),
        RaisedButton(
            onPressed: () async {
              String jsonString = '{ "title": "aliyun", "info": null }';
              Map<String, dynamic> parsedJson = json.decode(jsonString);
              await Future.delayed(Duration(milliseconds: 10));
              try {
                print(parsedJson['info']['domain']);
              } catch (error) {
                bool result = await EmasCrashlytics.instance.captureException(
                    error: error,
                    message: {
                      'key1': 'value1',
                      'key2': 'value2',
                      'key3': 'value3'
                    });
                print('采集到异常，上报${result ? '成功' : '失败'}，result:$result');
              }
            },
            child: Text('触发 Dart 空指针异常，\n同时上报自定义 Map 数据')),
        Divider(
          color: Colors.black,
          height: 30,
        ),
        GestureDetector(
          onTap: () {
            setState(() {
              showErrorWidget = !showErrorWidget;
            });
          },
          child: Row(
            mainAxisAlignment: MainAxisAlignment.center,
            children: [
              CupertinoSwitch(
                  value: showErrorWidget,
                  activeColor: Colors.blue,
                  onChanged: (bool value) {
                    setState(() {
                      showErrorWidget = !showErrorWidget;
                    });
                  }),
              Text('触发 Flutter Framework 异常', style: TextStyle(fontSize: 16))
            ],
          ),
        ),
        if (showErrorWidget == false)
          Container()
        else

          /// Flutter Framework 异常：渲染溢出
          Row(
            children: [
              Text('ABCDEFGHIJKLMNOPQRSTUVWXYZ' * 100),
            ],
          ),
      ],
    );
  }
}
